subroutine simubase(kp,bp,aa,valk,valb,indk,indb,vala,inda)

USE simuvar

real*8, intent(in)::                    kp,bp,aa

real*8, intent(out),dimension(2)::      valk,valb,vala
integer, intent(out),dimension(2)::   indk,indb,inda

integer::                             bbb
logical::                             elemk,elemb

elemk=.false.
bbb=1
do while ((.not. elemk) .and. (bbb<=lk-1))
	elemk=((K(bbb)<=kp) .and. (K(bbb+1)>=kp))
	bbb=bbb+1
end do

select case(elemk)

case(.true.)
	valk(2)=(kp-K(bbb-1))/(K(bbb)-K(bbb-1))
	valk(1)=(K(bbb)-kp)/(K(bbb)-K(bbb-1))
	indk(2)=bbb
	indk(1)=bbb-1

case(.false.)
	if (kp>K(lk)) then
		valk(2)=(kp-K(lk-1))/(K(lk)-K(lk-1))
		valk(1)=(K(lk)-kp)/(K(lk)-K(lk-1))
		indk(2)=lk
		indk(1)=lk-1
	end if
	if (kp<K(1)) then
		valk(2)=(kp-K(1))/(K(2)-K(1))
		valk(1)=(K(2)-kp)/(K(2)-K(1))
		indk(2)=2
		indk(1)=1
	end if
end select



elemb=.false.
bbb=1
do while ((.not. elemb) .and. (bbb<=lb-1))
	elemb=((b(bbb)<=bp) .and. (b(bbb+1)>=bp))
	bbb=bbb+1
end do

select case(elemb)

case(.true.)
	valb(2)=(bp-b(bbb-1))/(b(bbb)-b(bbb-1))
	valb(1)=(b(bbb)-bp)/(b(bbb)-b(bbb-1))
	indb(2)=bbb
	indb(1)=bbb-1

case(.false.)
	if (bp>b(lb)) then
		valb(2)=(bp-b(lb-1))/(b(lb)-b(lb-1))
		valb(1)=(b(lb)-bp)/(b(lb)-b(lb-1))
		indb(2)=lb
		indb(1)=lb-1
	end if
	if (bp<b(1)) then
		valb(2)=(bp-b(1))/(b(2)-b(1))
		valb(1)=(b(2)-bp)/(b(2)-b(1))
		indb(2)=2
		indb(1)=1
	end if
end select



elemb=.false.
bbb=1
do while ((.not. elemb) .and. (bbb<=la-1))
	elemb=((a(bbb)<=aa) .and. (a(bbb+1)>=aa))
	bbb=bbb+1
end do

select case(elemb)

case(.true.)
	vala(2)=(aa-a(bbb-1))/(a(bbb)-a(bbb-1))
	vala(1)=(a(bbb)-aa)/(a(bbb)-a(bbb-1))
	inda(2)=bbb
	inda(1)=bbb-1

case(.false.)
	if (aa>a(la)) then
		!vala(2)=(aa-a(la-1))/(a(la)-a(la-1))
		!vala(1)=(a(la)-aa)/(a(la)-a(la-1))
!		inda(2)=la
!		inda(1)=la-1
!	
		vala(2)=1
		vala(1)=0
		inda(2)=la
		inda(1)=la
	end if
	if (aa<a(1)) then
		vala(2)=(aa-a(1))/(a(2)-a(1))
		vala(1)=(a(2)-aa)/(a(2)-a(1))
		inda(2)=2
		inda(1)=1
	end if
end select
end subroutine simubase
