Module SimuVar

character*200, parameter:: sshock='shock9.dat' 
character*200,parameter:: dirin='./input/'
! Paramenters
integer, parameter            :: N  = 500,  T  = 1000,  NC = 64,  T1=44
integer, parameter            :: la =9,   lb = 400,   lk = la
integer, parameter            :: reada = 1
						        ! reada = 1: read in a process
					                ! reada = 0: test simple ar1 process
				    
real, parameter               :: amiu = 0.0,   rho = 0.995, sigmau = 0.042
real, parameter               :: istd = 1.0


integer, parameter            :: isav = 1   ! isav == 1: savings is defined as GDP minus consumption
                                            ! isav == 2: savings is defined as GNP minus consumption

real, parameter               :: alpha = 0.33,  sigma = 2.0, delta = 0.10, beta1 = 1/1.04
real, parameter               :: bmin = -10.0,  bmax = 10.0

real, dimension(la)           :: a, Ea
real, dimension(la,la)        :: p
real, dimension(la)           :: inc
real, dimension(la,la)        :: W
real, dimension(lb,lk,la)     :: gk, gc  
real, dimension(lb,lk,la,la)  :: gb  
real, dimension(la*lb*lk)     :: miu 

real, dimension(lb)           :: b
real, dimension(la)           :: k

real                          :: R

real, dimension(la*lb*lk)     :: cummiu
real, dimension(la,la)        :: cumpai
contains
!************************************
subroutine meanstd(nx,x,meanx,stdx)

implicit none
integer,intent(in)       :: nx
real*8, intent(in)         :: x(nx)
real*8, intent(out)        :: meanx,stdx

real*8                     :: tmp(nx), tmp2

if (nx==1) then
	!print *, 'Variable only has one number'
	meanx = x(1)
	stdx  = 0
else
	meanx = sum(x)/real(nx)
	tmp = (x-meanx)**2.0
	tmp2 = sum(tmp)/real(nx-1)
	stdx = sqrt(tmp2)
end if

end subroutine meanstd


End Module SimuVar





































