subroutine guess

Use penfvar

implicit none

integer                              :: i, j, m, ii, itmp, iap
real, dimension(la*lw*la)            :: tgw

real, dimension(la,lw)               :: ttgk, ttvw
real, allocatable,dimension(:,:)     :: ttgw

real                                 :: temp1, temp2, aa, bb
real, dimension(2)                   :: valw
integer, dimension(2)                :: indw

external basew

allocate(ttgw(indexp, lwl))

if (readg==0) then
	do i=1,la
		do j=1,lw
			gk(i,j)  = ((R-1.0+delta)/(alpha*Ea(i)))**(-talpha)
			if (i==1) then
				vw(i,j)  = 0.01 + 8.0 *(W(j) - wmin)**2.0
			else
				vw(i,j)  = 0.80 * (0.001 + 7.0 *(W(j) - wmin)**2.0)
			end if
		end do
	end do
	do i=1,indexp
		do j=1,lw
			gw(i,j)  = W(j)-0.03*real(j-1)
		end do
	end do
elseif (readg==1) then  ! Read in result from value function results
	rewind (40)
	rewind (42)
	rewind (44)
	do i=1,la
		do j=1,lw
			read (42,*) gk(i,j)
			read (44,*) vw(i,j)
			do ii = 1, la
				read(40,*) tgw((i-1)*lw*la+(j-1)*la+ii)
			end do
		end do
	end do

	icount = 1
	do i=1,la
		do j = ipp(i), ipp(i+1)-1
			iap  = jpp(j)
			do m = 1, lw
				gw(icount,m) = tgw((i-1)*lw*la+(m-1)*la+iap)
			end do
			!print *, gw(icount,:)
			icount = icount + 1
		end do
	end do
	rewind (40)
	rewind (42)
	rewind (44)
	rewind(22)
	do i = 1, indexp
		do j = 1, lw
			write (22,*) gw(i,j)
		end do
	end do
	rewind (22)

elseif (readg==3) then   !Read in complete market result
	do i=1,la
		do j=1,lw
			gk(i,j)  = kc(i)
			vw(i,j)  = cvw(i,j)
		end do
	end do
	do i=1,indexp
		do j=1,lw
			gw(i,j)  = W(j)
		end do
	end do

else
	rewind (22)
	rewind (23)
	rewind (24)
	if (iwc  == 0) then
		do i=1,la
			do j=1,lw
				read (23,*) gk(i,j)
				read (24,*) vw(i,j)
			end do
		end do

		do i=1,indexp
			do j = 1,lw
				read (22,*) gw(i,j)
			end do
		end do
	else
		if (lw-lwl>0) then
			do i=1,la
				do j=1,lwl
					read (23,*) ttgk(i,j)
					read (24,*) ttvw(i,j)
				end do
			end do
			do i=1,indexp
				do j = 1,lwl
					read (22,*) ttgw(i,j)
				end do
			end do
			do i = 1,la
				do j = 1, lwl
					itmp   = j +lw-lwl
					call basew(W(itmp), valw, indw)
					gk(i, itmp)  = ttgk(i,indw(1))*valw(1)+ttgk(i,indw(2))*valw(2)
					vw(i, itmp)  = ttvw(i,indw(1))*valw(1)+ttvw(i,indw(2))*valw(2)
				end do
			end do
			
			do i=1,indexp
				do j = 1,lwl
					itmp   = j +lw-lwl
					call basew(W(itmp), valw, indw)
					gw(i,itmp)      = ttgw(i,indw(1))*valw(1)+ttgw(i,indw(2))*valw(2)
				end do
			end do			
	
			do i = 1, la
				temp1    = vw(i, lw-lwl+1)
				temp2    = vw(i, lw-lwl+2)
				aa       = (temp2 - temp1)/(W(lw-lwl+2)-W(lw-lwl+1))
				bb       = vw(i, lw-lwl+1) - aa * W(lw-lwl+1)
				do j = 1,lw-lwl
					gk(i,j)  = gk(i,lw-lwl+1)
					vw(i,j)  = aa*W(j) + bb
				end do
			end do
			do i = 1, indexp
				gw(i,1:lw-lwl)  = gw(i,lw-lwl+1)
			end do
			
			!print *, 'gk', gk(1,lw-8:lw)
			!print *, 'gw', gw(:,1)
			
			!stop
		
		elseif (lw-lwl<0) then
			print *, 'Read in guess'
			do i=1,la
				do j=1,lwl
					read (23,*) ttgk(i,j)
					read (24,*) ttvw(i,j)
				end do
			end do
			do i=1,indexp
				do j = 1,lwl
					read (22,*) ttgw(i,j)
				end do
			end do
			do i = 1,la
				do j = 1, lw
					gk(i, j)  = ttgk(i,(j-1)*2+1)
					vw(i, j)  = ttvw(i,(j-1)*2+1)
				end do
			end do
			
			do i=1,indexp
				do j = 1,lw
					gw(i,j)      = ttgw(i,(j-1)*2+1)
				end do
			end do
			print *, 'Done Read in guess'

		else
			do i=1,la
				do j=1,lwl
					read (23,*) ttgk(i,j)
					read (24,*) ttvw(i,j)
				end do
			end do
			do i=1,indexp
				do j = 1,lwl
					read (22,*) ttgw(i,j)
				end do
			end do
			do i = 1,la
				do j = 1, lwl
					itmp   = j +lw-lwl
					call basew(W(itmp), valw, indw)
					gk(i, itmp)  = ttgk(i,indw(1))*valw(1)+ttgk(i,indw(2))*valw(2)
					vw(i, itmp)  = ttvw(i,indw(1))*valw(1)+ttvw(i,indw(2))*valw(2)
				end do
			end do
			
			do i=1,indexp
				do j = 1,lwl
					itmp   = j +lw-lwl
					call basew(W(itmp), valw, indw)
					gw(i,itmp)      = ttgw(i,indw(1))*valw(1)+ttgw(i,indw(2))*valw(2)
				end do
			end do					
		end if
	end if
	rewind (22)
	rewind (23)
	rewind (24)
end if

end subroutine guess 