subroutine intaut(kp, uaut, duaut)


use penfvar
implicit none

real, intent(in)                 :: kp
real, intent(out), dimension(la) :: uaut, duaut

integer                          :: i
real                             :: dbsval, dbsder, temp1, temp2

external dbsval, dbsder

! kxord=2
if (kp>=autkmin) then
	do i=1,la
		uaut(i)  = dbsval(kp, kxord, xknot, autlk, bscoef(i,:))
		duaut(i) = dbsder(1, kp, kxord, xknot, autlk, bscoef(i,:))
	end do
else
	temp1 = (autk(2)-kp)/(autk(2)-autk(1))
	temp2 = (kp-autk(1))/(autk(2)-autk(1))
	do i=1,la
		uaut(i)  = temp1*autu(i,1)+temp2*autu(i,2)
		duaut(i) = temp1*autud(i,1)+temp2*autud(i,2)
	end do

end if
end subroutine intaut
