Subroutine readin

USE regimeVar

IMPLICIT NONE

integer                                  :: i,j

!********************
! Read in data
rewind(5)
rewind(9)
do i=1,NC
	do j=1,T+1
		read(5,*) dpshock(i,j)
	end do
end do

if (icalamda==1) then
	do i=1,NC
		do j=1,T+1
			read(9,*) cc(i,j)
		end do
	end do
else
	cc=0.0
end if


rewind(5)
rewind(9)

!********************
! Read in initial guess
if (readp==0) then 
	lamda=0.0
	do i=1,N
		read(7,*) rou(i)
	end do

	do i=1,N
		read(7,*) mu(i)
	end do

	do i=1,N
		read(7,*) sigma(i)
	end do

	
	do i=1,N
		do j=1,N
			read(7,*) p(i,j)
		end do
	end do

	do i=1,N
		read(7,*) pai(i)
	end do

	do i=1,N
		read(7,*) phi(i)
	end do
	rewind(7)
else
	lamda=0.0
	do i=1,N
		read(8, *) mu(i)
		read(8, *) rou(i)
		read(8, *) sigma(i)
	end do
	do i=1,N
		do j=1,N
			read(8, *) p(i,j)
		end do
	end do
	do i=1,N
		read(8, *) pai(i)
	end do

	rewind(8)
	phi   = 0.999
end if


End subroutine readin



