subroutine bpolicy(v0,setib,setik,setkp,setbp,setc,setikp,setibp)

use bvar
implicit none

real*8, intent(in), dimension(la,lb,lk)           :: v0
integer, intent(out),dimension(la,lb,lk)          :: setib,setik
real*8, intent(out), dimension(la,lb,lk)          :: setkp,setbp, setc
integer, intent(out), dimension(la*lb*lk)         :: setibp,setikp

real*8                               :: Ev,u,c, tmp, vv
real*8                               :: cc, tt2,tt3
integer                              :: i,j,m,mm,i1,ii,jj, iter
real*8                               :: inv


logical                              :: twoc

! Compute the policy rule
do i = 1, la
	do j = 1,lb
		do m = 1, lk
			vv   = pen
			ikp  = 1
			ibp  = 1
			cc   = 0.0
			if (test(i, j, m) == 1.0) then
				do mm = 1,lk   !k'
					do jj = ibbar0(i, j,m), lb !b'
						if (test(i,jj,mm)==1.0) then
							c   = ff(i,m)+R*b(j) - K(mm) - b(jj)-tao*abs(b(jj)) - gama*(K(mm)/K(m)-1.0+delta)**2.0*k(m)/2.0
							inv = K(mm) - (1.0-delta)*K(m)
							
							if (c > 0.0) then
								u      = (c**(1.0-sigma)-1.0)/(1.0-sigma)
								Ev   = sum(p(i,:)*v0(:,jj,mm))
								tmp    = (1.0 - beta) * u + beta * Ev
								if (tmp > vv) then
									vv   = tmp
									ikp  = mm
									ibp  = jj
									cc   = c
								end if
							end if
						end if
					end do ! End of iteration over k'
				end do ! End of iteration over b'
			end if
			setik(i,j,m) = ikp
			setib(i,j,m) = ibp
			setkp(i,j,m) = K(ikp)
			setbp(i,j,m) = b(ibp)
			setc(i,j,m)  = cc
			setikp((i-1)*lk*lb+(j-1)*lk+m) = setik(i,j,m)
			setibp((i-1)*lk*lb+(j-1)*lk+m) = setib(i,j,m)
		end do !End of iteration over k
	end do ! End of iteration over b
end do ! End of iteration over A

end subroutine bpolicy
