SRC = /Users/jzhang/KMBond/Bond_Routines
#COMPILER = /export/apps/pgi/linux86-64/7.2/mpi2/mpich/bin/mpif90
#COMPILER2 = /export/apps/pgi/linux86-64/7.2/mpi2/mpich/bin/mpif77
COMPILER = mpif90
COMPILER2 = mpif77
target= bond.out

$(target):bvar.o fset.o breadin.o blassm.o formats.o matvec.o unary.o biterV.o bpolicy.o biterR.o biterBeta.o bdist.o bwrite.o bmain.o
	$(COMPILER)  bvar.o fset.o breadin.o blassm.o formats.o matvec.o unary.o biterV.o bpolicy.o biterR.o biterBeta.o bdist.o bwrite.o bmain.o \
		-o $(target)
	rm *.o *.mod

bvar.o:$(SRC)/bvar.f90
	$(COMPILER) -c $(SRC)/bvar.f90

fset.o:$(SRC)/fset.f90
	$(COMPILER) -c $(SRC)/fset.f90

breadin.o:$(SRC)/breadin.f90
	$(COMPILER) -c $(SRC)/breadin.f90

biterV.o:$(SRC)/biterV.f90
	$(COMPILER) -c $(SRC)/biterV.f90

bpolicy.o:$(SRC)/bpolicy.f90
	$(COMPILER) -c  $(SRC)/bpolicy.f90

biterR.o:$(SRC)/biterR.f90
	$(COMPILER) -c $(SRC)/biterR.f90

biterBeta.o:$(SRC)/biterBeta.f90
	$(COMPILER) -c $(SRC)/biterBeta.f90

bdist.o:$(SRC)/biterV.f90
	$(COMPILER) -c $(SRC)/bdist.f90

bwrite.o:$(SRC)/bwrite.f90
	$(COMPILER) -c $(SRC)/bwrite.f90

formats.o:$(SRC)/formats.f
	$(COMPILER2) -c $(SRC)/formats.f

blassm.o:$(SRC)/blassm.f
	$(COMPILER2) -c $(SRC)/blassm.f

unary.o:$(SRC)/unary.f
	$(COMPILER2)  -c $(SRC)/unary.f

matvec.o:$(SRC)/matvec.f
	$(COMPILER2) -c $(SRC)/matvec.f

bmain.o:$(SRC)/bmain.f90
	$(COMPILER) -c $(SRC)/bmain.f90
