SRC = ./Bondenf_Routines
COMPILER = mpif90
COMPILER2 = mpif77
target = bondenf.out

benf:bondenforcevar.o fset.o initial.o autarkyv.o biterV.o bpolicy.o biterV0.o biterR.o bdist.o blassm.o formats.o matvec.o unary.o bondenforce.o
	$(COMPILER)  bondenforcevar.o fset.o initial.o autarkyv.o biterV.o bpolicy.o biterV0.o biterR.o bdist.o blassm.o formats.o matvec.o unary.o bondenforce.o \
		-o $(target)
	rm *.o *.mod

bondenforcevar.o:$(SRC)/bondenforcevar.f90
	$(COMPILER) -c $(SRC)/bondenforcevar.f90

fset.o:$(SRC)/fset.f90
	$(COMPILER) -c $(SRC)/fset.f90

initial.o:$(SRC)/initial.f90
	$(COMPILER) -c $(SRC)/initial.f90

autarkyv.o:$(SRC)/autarkyv.f90
	$(COMPILER) -c $(SRC)/autarkyv.f90

biterV.o:$(SRC)/biterV.f90
	$(COMPILER) -c $(SRC)/biterV.f90

bpolicy.o:$(SRC)/bpolicy.f90
	$(COMPILER) -c $(SRC)/bpolicy.f90

biterV0.o:$(SRC)/biterV0.f90
	$(COMPILER) -c $(SRC)/biterV0.f90

biterR.o:$(SRC)/biterR.f90
	$(COMPILER) -c $(SRC)/biterR.f90

bdist.o:$(SRC)/bdist.f90
	$(COMPILER) -c $(SRC)/bdist.f90

formats.o:$(SRC)/formats.f
	$(COMPILER2) -c $(SRC)/formats.f

blassm.o:$(SRC)/blassm.f
	$(COMPILER2) -c $(SRC)/blassm.f

unary.o:$(SRC)/unary.f
	$(COMPILER2)  -c $(SRC)/unary.f

matvec.o:$(SRC)/matvec.f
	$(COMPILER2) -c $(SRC)/matvec.f

bondenforce.o:$(SRC)/bondenforce.f90
	$(COMPILER) -c $(SRC)/bondenforce.f90
	
