Subroutine timeStat(simuc,simuy,simui,simuk,mtime,stime)

USE simuVar
implicit none

real*8, intent(in), dimension(T,NC):: simuc,simuy,simui,simuk
real*8,intent(out),dimension(ntvar) :: mtime,stime
! working arrays
real*8:: neta(T,NC),mdsc,mdsy,myn,mdsk,mdsi
real*8,dimension(T):: sc,sy,si,sk,sn,tsc,tsy,tsi,tsk,tsn,dsc,dsy,dsk,dsn,ss, dsi,dss,tss,iyy
real*8,dimension(NC):: cyc,cyn,sdsc,sdsy,syn,sdsk,w,cyi,sdsi,csi,sgy,sgi,sgs,cgsi,cgdi
real*8:: cdc(T,2),cdy(T,2),ccc,yyy,gsi(T-1),mgsi, simus(T,NC), gss(T-1),gsy(T-1),mgi,mgs,mgy
integer:: i,j,iterr
real*8:: m1,d1,d2

neta=simuy-simuc-simui
simus=simuy-simuc
cgdi=1.0e10
iterr=0
do i=1,NC
	sc(1)=simuc(1,i)
	sy(1)=simuy(1,i)
	si(1)=simui(1,i)
	sk(1)=simuk(1,i)
	sn(1)=neta(1,i)
	ss(1)=simus(1,i)

	do j=2,T
		sc(j)=simuc(j,i)*gt**real(j-1)
		sy(j)=simuy(j,i)*gt**real(j-1)
		si(j)=simui(j,i)*gt**real(j-1)
		sk(j)=simuk(j,i)*gt**real(j-1)
		sn(j)=neta(j,i)*gt**real(j-1)
		ss(j)=simuc(j,i)*gt**real(j-1)
	end do
	sn = sn/sy
	! Hp filter all the series

	w=100.0
	call hpfilter(sc,tsc,dsc,T,w)
	call hpfilter(sy,tsy,dsy,T,w)
	call hpfilter(sk,tsk,dsk,T,w)
	call hpfilter(ss,tss,dss,T,w)	
	call hpfilter(si,tsi,dsi,T,w)
	
!	dsc=simuc(:,i)
!	dsy=simuy(:,i)
!	dsk=simuk(:,i)
!	dss=simus(:,i)
	iyy=simui(:,i)/simuy(:,i)
!	dsi = simui(:,i)
	
	if (i<=2) then
		cdc(:,i)=dsc
		cdy(:,i)=dsy
	end if
	if (i==2) then
		call fcorr(T,cdc(:,1),cdc(:,2),ccc)
		call fcorr(T,cdy(:,1),cdy(:,2),yyy)	
	end if

	gsi=simui(2:T,i)/simui(1:T-1,i)-1
	
	gss=simus(2:T,i)/simus(1:T-1,i)-1
	gsy=simuy(2:T,i)/simuy(1:T-1,i)-1

!	call meanstd(T,simuy(:,i),m1,d1)
!	call meanstd(T,simui(:,i),m1,d2)
	
	if (sum(gsi**2.0)>0) then
		iterr=iterr+1	
		call meanstd(T,dsy,mdsy,sdsy(iterr))

		call meanstd(T,dsi,mdsi,sdsi(iterr))
		call meanstd(T,dsc,mdsc,sdsc(iterr))
	
		call meanstd(T,sn,myn,syn(iterr))
		call meanstd(T,dsk,mdsk,sdsk(iterr))
	
		call meanstd(T,gsy,mgy,sgy(iterr))
		call meanstd(T,gsi,mgi,sgi(iterr))
		call meanstd(T,gss,mgs,sgs(iterr))
	
		call fcorr(T,dsc,dsy,cyc(iterr))
		call fcorr(T,sn/sy,dsy,cyn(iterr))
		call fcorr(T,gsi,gsy,cyi(iterr))
		call fcorr(T,dsi,dss,csi(iterr))	
		
		call fcorr(T-1,gsi,gss,cgsi(iterr))	
		call fcorr(T-1,gsi,dss(2:T),cgdi(iterr))	
	end if 
	
end do


call meanstd(iterr,sdsc(1:iterr)/sdsy(1:iterr),mtime(1),stime(1))
call meanstd(iterr,sdsy(1:iterr),mtime(2),stime(2))
call meanstd(iterr,cyc(1:iterr),mtime(3),stime(3))
call meanstd(iterr,cyn(1:iterr),mtime(4),stime(4))
call meanstd(iterr,syn(1:iterr),mtime(5),stime(5))
call meanstd(iterr,sdsk(1:iterr)/sdsy(1:iterr),mtime(6),stime(6))
call meanstd(iterr,cyi(1:iterr),mtime(9),stime(9))
call meanstd(iterr,sgi(1:iterr)/sgy(1:iterr),mtime(10),stime(10))
call meanstd(iterr,csi(1:iterr),mtime(11),stime(11))
call meanstd(iterr,cgsi(1:iterr),mtime(12),stime(12))
call meanstd(iterr,cgdi(1:iterr),mtime(13),stime(13))
call meanstd(iterr,sdsi(1:iterr)/sdsy(1:iterr),mtime(14),stime(14))


mtime(7)=ccc
mtime(8)=yyy


end subroutine timeStat