subroutine writeout

USE penfvar

IMPLICIT NONE
integer                             :: i, j ,m

! Write out the result of autu and autkp
rewind(9)
do i=1, autlk
	write(9,*) autk(i)
end do
rewind(9)

rewind(10)
rewind(12)
rewind(40)
do i=1,la
	do j=1,autlk
		write (10,*) autu(i,j)
		write (12,*) autkp(i,j)
		write (40,*) vwp(i,j)
	end do
end do
rewind(10)
rewind(12)
rewind(40)


! Write out the sparse matrix of p
rewind(13)
write (13,*) indexp
do i = 1, indexp
	write (13,*) pp(i)
end do
do i = 1, indexp
	write (13,*) jpp(i)
end do
do i = 1, indexip
	write (13,*) ipp(i)
end do
rewind(13)

rewind(50)
do i = 1,la
	write(50,*) A(i)
end do
do i=1,la
	do j=1,la
		write(50,*) p(i,j)
	end do
end do
rewind(50)

rewind(7)
do i=1, lk
	write(7,*) K(i)
end do
rewind(7)

rewind(8)
do i = 1,lw
	write(8,*) W(i)
end do
rewind(8)

rewind(22)
rewind(23)
rewind(24)
rewind(38)
rewind(32)
rewind(34)
rewind(36)
rewind(82)
do i=1, la
	do j=1,lw
		write(23,*) gk(i,j)
		write(24,*) vw(i,j)
		write(32,*) gh(i,j)
		write(34,*) v(i,j)
		write(82,*) indenf(i,j)
		do m=1,lk
			write (36,*) -vt(i,m,j)    !vt(a,k,w)   write out in the order of (a w k)
		end do
	end do
end do

do i=1,indexp
	do j=1,lw
		!print *, 'hi gw', i,j
		write (22,*) gw(i,j)
		write (38,*) mgama(i,j)
	end do
end do
rewind(22)
rewind(23)
rewind(24)
rewind(38)
rewind(32)
rewind(34)
rewind(36)

rewind(26)
do i=1,la*lw*lk
	write(26,*) den(i)
end do
rewind(26)

! *********************************************************************************

rewind(80)
write (80, *) 'beta:          ', beta
write (80, *) 'R:             ', R
write (80, *) 'delta:         ', delta
write (80, *) 'alpha:         ', alpha
write (80, *) 'lamda:         ', lamda
write (80, *) 'sigma:         ', sigma
write (80, *) 'rou:           ', rou
write (80, *) 'la:            ', la
write (80, *) 'lw:            ', lw
write (80, *) 'lk:            ', lk
write (80, *) 'wmin:          ', wmin
write (80, *) 'wmax:          ', wmax
write (80, *) 'kmin:          ', kmin
write (80, *) 'kmax:          ', kmax
write (80, *) 'excess demand: ', exd
rewind(80)


!Write out parameters used
rewind(5)
write(5,15) R
write(5,15) beta
write(5,15) delta
write(5,15) alpha
write(5,15) sigma
write(5,15) lamda
write(5,15) kmin
write(5,15) kmax
write(5,15) wmin
write(5,15) wmax
write(5,11) la
write(5,15) rou
rewind(5)
!Write out parameters used
rewind(11)
write(11,11) la
write(11,11) lw
write(11,15) wmin
write(11,15) wmax
rewind(11)
10 format(E15.3,E15.3,E15.3)
11 format(I4)
12 format(E15.5,E15.5,E15.5,E15.5,E15.5,E15.5)
15 format(E15.5)

end subroutine writeout