subroutine simubase(kp,wp,valk,valw,indk,indw)

USE simuvar
implicit none

real, intent(in)::                    kp,wp

real, intent(out),dimension(2)::      valk,valw
integer, intent(out),dimension(2)::   indk,indw

integer::                             bbb
logical::                             elemk,elemw

elemk=.false.
bbb=1
do while ((.not. elemk) .and. (bbb<=lk-1))
	elemk=((K(bbb)<=kp) .and. (K(bbb+1)>=kp))
	bbb=bbb+1
end do

select case(elemk)

case(.true.)
	valk(2)=(kp-K(bbb-1))/(K(bbb)-K(bbb-1))
	valk(1)=(K(bbb)-kp)/(K(bbb)-K(bbb-1))
	indk(2)=bbb
	indk(1)=bbb-1

case(.false.)
	if (kp>K(lk)) then
		valk(2)=(kp-K(lk-1))/(K(lk)-K(lk-1))
		valk(1)=(K(lk)-kp)/(K(lk)-K(lk-1))
		indk(2)=lk
		indk(1)=lk-1
	end if
	if (kp<K(1)) then
		valk(2)=(kp-K(1))/(K(2)-K(1))
		valk(1)=(K(2)-kp)/(K(2)-K(1))
		indk(2)=2
		indk(1)=1
	end if
end select



elemw=.false.
bbb=1
do while ((.not. elemw) .and. (bbb<=lw-1))
	elemw=((W(bbb)<=wp) .and. (W(bbb+1)>=wp))
	bbb=bbb+1
end do

select case(elemw)

case(.true.)
	valw(2)=(wp-W(bbb-1))/(W(bbb)-W(bbb-1))
	valw(1)=(W(bbb)-wp)/(W(bbb)-W(bbb-1))
	indw(2)=bbb
	indw(1)=bbb-1

case(.false.)
	if (wp>W(lw)) then
		valw(2)=(wp-W(lw-1))/(W(lw)-W(lw-1))
		valw(1)=(W(lw)-wp)/(W(lw)-W(lw-1))
		indw(2)=lw
		indw(1)=lw-1
	end if
	if (wp<W(1)) then
		valw(2)=(wp-W(1))/(W(2)-W(1))
		valw(1)=(W(2)-wp)/(W(2)-W(1))
		indw(2)=2
		indw(1)=1
	end if
end select
end subroutine simubase