! Solve invariant distribution of a according to transition matrix P

Subroutine invariantp(nn,pp,invp)

Implicit None

integer,intent(in)                 :: nn
real*8,intent(in),dimension(nn,nn)   :: pp
real*8,intent(out),dimension(nn)     :: invp

!Arrays for calculationg invariant distribution of p
complex, dimension(nn)             :: eval
complex, dimension(nn,nn)          :: evec
real*8, dimension(nn)                :: reval
real*8, dimension(nn,nn)             :: revec, tmpm, invevec, tmpm1, tmpmm


call devcrg(nn,pp,nn,eval,evec,nn)

reval  = real(eval)
revec  = real(evec)
tmpm      = 0.0
tmpm(1,1) = 1.0

call dlinrg(nn,revec,nn,invevec,nn)


tmpm1     = matmul(tmpm,invevec)
tmpmm     = matmul(revec,tmpm1) 

invp      = tmpmm(1,:)   ! Invariant distribution

End Subroutine invariantp

